
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the EPCSDK_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// EPCSDK_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef EPCSDK_EXPORTS
#define EPCSDK_API __declspec(dllexport)
#else
#define EPCSDK_API __declspec(dllimport)
#endif
#ifndef HANDLE
typedef int HANDLE;
#endif

 HANDLE  OpenComm(int portNo);	// COM 1-9. Return -1(INVALID_HANDLE_VALUE) if failed.
 void   CloseComm(HANDLE hCom);
 bool  ReadFirmwareVersion(HANDLE hCom, int* main, int* sub,char ReaderAddr);

 bool  GetReaderParameters(HANDLE hCom, int addr, int paramNum, char* params,char ReaderAddr);
 bool  SetReaderParameters(HANDLE hCom, int addr, int paramNum, const char* params,char ReaderAddr);

 bool  StopReading(HANDLE hCom,char ReaderAddr);
 bool  ResumeReading(HANDLE hCom,char ReaderAddr);

 bool   IdentifySingleTag(HANDLE hCom, char* tagID, char* antennaNo,char ReaderAddr);	// tagID: 12 Bytes, antennaNo: 1 Byte
 bool   IdentifyUploadedSingleTag(HANDLE hCom, char* tagID, char* devNo=0, char* antennaNo=0);	// tagID: 12 Bytes, devNo: 1 Byte, antennaNo: 1 Byte
 bool   IdentifyUploadedMultiTags(HANDLE hCom, char* tagNum, char* tagIDs, char* devNos=0, char* antennaNos=0);	// tagNum : 1 Byte, tagIDs: N * 12 Bytes, devNos: N Bytes, antennaNos: N Bytes (N < 50)

 bool   ReadTIDByEpcID(HANDLE hCom, const char* chars,char* data,char ReaderAddr);
 bool   ReadByEpcID(HANDLE hCom, char memBank, char address, char WordCount,const char* EpcID, char* data,char ReaderAddr);

 bool   ReadTag(HANDLE hCom, char memBank, char address, char length, char* data,char ReaderAddr);
 bool   WriteTagSingleWord(HANDLE hCom, char memBank, char address, char data1, char data2,char ReaderAddr);
 bool   WriteByEpcID(HANDLE hCom, char memBank, char address, char WordCount,const char* EpcID,char* data,char ReaderAddr);//<xxm 110814
 bool   WriteTagMultiWord(HANDLE hCom, char memBank, char address, char WordCount,const char* chars,char ReaderAddr); //<XXM 110425
 bool   FastWriteTagID(HANDLE hCom, int charsNum, const char* chars,char ReaderAddr);		// 2, 4, 6, 8, 10, 12 Bytes
 bool   FastWriteTagID_Lock(HANDLE hCom, int charsNum, const char* chars,char ReaderAddr);	// 2, 4, 6, 8, 10, 12 Bytes
 bool   FastWriteTag(HANDLE hCom, char memBank, char address, char WordCount,const char* chars,char ReaderAddr);
 bool   InitializeTag(HANDLE hCom,char ReaderAddr);
// bool   LockTag(HANDLE hCom, char lockType,char ReaderAddr);	// lockType => 00: LOCK USER, 01: LOCK TID, 02: LOCK EPC, 03: LOCK ACCESS, 04: LOCK KILL, 05: LOCK ALL, other: DO NOT LOCK
 bool   LockPassWordTag(HANDLE hCom,char passwd1,char passwd2,char passwd3,char passwd4,char lockType,char ReaderAddr);// lockType => 00: LOCK USER, 01: LOCK TID, 02: LOCK EPC, 03: LOCK ACCESS, 04: LOCK KILL, 05: LOCK ALL, other: DO NOT LOCK
 bool   UnlockPassWordTag(HANDLE hCom,char passwd1,char passwd2,char passwd3,char passwd4,char lockType,char ReaderAddr);// lockType => 00: LOCK USER, 01: LOCK TID, 02: LOCK EPC, 03: LOCK ACCESS, 04: LOCK KILL, 05: LOCK ALL, other: DO NOT LOCK
 bool   KillTag(HANDLE hCom, char passwd1, char passwd2, char passwd3, char passwd4,char ReaderAddr);
